//+------------------------------------------------------------------+
//|                                          stochastic daily EA.mq4 |
//|                      Copyright  2005, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Morpheus."
#property link      ""

extern int MagicNumber=211397;

extern double stoploss=25;
extern double lTakeProfit = 50;
extern double sTakeProfit = 50;
extern double lTrailingStop = 20;
extern double sTrailingStop = 20;
extern color clOpenBuy = Blue;
extern color clCloseBuy = Aqua;
extern color clOpenSell = Red;
extern color clCloseSell = Violet;
extern color clModiBuy = Blue;
extern color clModiSell = Red;
extern string Name_Expert = "stochastic DAily EA";
extern int Slippage = 2;
extern bool UseSound = False;
extern string NameFileSound = "alert.wav";
extern double Lots = 1.3;





void deinit() {
   Comment("");
}
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int start(){
   if(Bars<100){
      Print("bars less than 100");
      return(0);
   }
 

 
 
  
  double stoch1=iStochastic(NULL,PERIOD_D1,5,3,3,MODE_EMA,1,MODE_MAIN,0);
 
double stochsig=iStochastic(NULL,PERIOD_D1,5,3,3,MODE_EMA,1,MODE_SIGNAL,0);

  double stoch2=iStochastic(NULL,PERIOD_D1,5,3,3,MODE_EMA,1,MODE_MAIN,3);
 
double stochsig2=iStochastic(NULL,PERIOD_D1,5,3,3,MODE_EMA,1,MODE_SIGNAL,3);
 
 
 
  double RSI = iRSI(NULL,PERIOD_M5,14,PRICE_WEIGHTED,0);
double RSI2 = iRSI(NULL,PERIOD_M5,14,PRICE_WEIGHTED,7);
double RSIM1 = iRSI(NULL,PERIOD_M15,14,PRICE_WEIGHTED,0);
double RSIM2 = iRSI(NULL,PERIOD_M15 ,14,PRICE_WEIGHTED,7);

double RSIL1 = iRSI(NULL,PERIOD_M30 ,14,PRICE_WEIGHTED,0);
double RSIL2 = iRSI(NULL,PERIOD_M30 ,14,PRICE_WEIGHTED,7);
   
   
double RSID1 = iRSI(NULL,PERIOD_D1 ,14,PRICE_WEIGHTED,0);
double RSID2 = iRSI(NULL,PERIOD_D1 ,14,PRICE_WEIGHTED,4);
 
   
 
   if(AccountFreeMargin()<(1000*Lots)){
      Print("We have no money. Free Margin = ", AccountFreeMargin());
      return(0);
   }
   if (!ExistPositions()){

    if (stoch1<stochsig && stoch2>stochsig2  ){
        OpenSell();
         return(0);
      }
      
      
       if (stoch1>stochsig && stoch2<stochsig2   ){
         OpenBuy();
         return(0);
      }
      
   }
   
   
   
   
   
   TrailingPositionsBuy(lTrailingStop);
   TrailingPositionsSell(sTrailingStop);
   return (0);
}

bool ExistPositions() {
for (int i=0; i<OrdersTotal(); i++) {
if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) {
if (OrderSymbol()==Symbol()  && OrderMagicNumber()==MagicNumber) {
return(True);
}
} 
} 
return(false);
}
void TrailingPositionsBuy(int trailingStop) { 
   for (int i=0; i<OrdersTotal(); i++) { 
      if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) { 
         if (OrderSymbol()==Symbol()  && OrderMagicNumber()==MagicNumber) { 
            if (OrderType()==OP_BUY) { 
               if (Bid-OrderOpenPrice()>trailingStop*Point) { 
                  if (OrderStopLoss()<Bid-trailingStop*Point) 
                     ModifyStopLoss(Bid-trailingStop*Point); 
               } 
            } 
         } 
      } 
   } 
} 
void TrailingPositionsSell(int trailingStop) { 
   for (int i=0; i<OrdersTotal(); i++) { 
      if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) { 
         if (OrderSymbol()==Symbol() && OrderMagicNumber()==MagicNumber) { 
            if (OrderType()==OP_SELL) { 
               if (OrderOpenPrice()-Ask>trailingStop*Point) { 
                  if (OrderStopLoss()>Ask+trailingStop*Point || 
OrderStopLoss()==0)  
                     ModifyStopLoss(Ask+trailingStop*Point); 
               } 
            } 
         } 
      } 
   } 
} 
void ModifyStopLoss(double ldStopLoss) { 
   bool fm;
   fm = OrderModify(OrderTicket(),OrderOpenPrice
(),ldStopLoss,OrderTakeProfit(),0,CLR_NONE); 
   if (fm && UseSound) PlaySound(NameFileSound); 
} 

void OpenBuy() { 
   double ldLot, ldStop, ldTake; 
   string lsComm; 
   ldLot = GetSizeLot(); 
   ldStop = Bid-stoploss*Point; 
   ldTake = GetTakeProfitBuy(); 
   lsComm = GetCommentForOrder(); 
   OrderSend(Symbol
(),OP_BUY,ldLot,Ask,Slippage,ldStop,ldTake,lsComm,MagicNumber,0,clOpenBuy); 
   if (UseSound) PlaySound(NameFileSound); 
} 
void OpenSell() { 
   double ldLot, ldStop, ldTake; 
   string lsComm; 

   ldLot = GetSizeLot(); 
   ldStop = Ask+stoploss*Point; 
   ldTake = GetTakeProfitSell(); 
   lsComm = GetCommentForOrder(); 
   OrderSend(Symbol
(),OP_SELL,ldLot,Bid,Slippage,ldStop,ldTake,lsComm,MagicNumber,0,clOpenSell); 
   if (UseSound) PlaySound(NameFileSound); 
} 
string GetCommentForOrder() { return(Name_Expert); } 
double GetSizeLot() { return(Lots); } 
double GetTakeProfitBuy() { return(Ask+lTakeProfit*Point); } 
double GetTakeProfitSell() { return(Bid-sTakeProfit*Point); } 